OpenTTD Source: BuildVehicleWindow Struct Reference

OpenTTD Source 15.3

Public Member Functions | Data Fields | Static Public Attributes
BuildVehicleWindow Struct Reference

GUI for building vehicles. More...

Inheritance diagram for BuildVehicleWindow:

## Public Member Functions
void | SetBuyVehicleText ()
| BuildVehicleWindow (WindowDesc &desc, TileIndex tile, VehicleType type)
void | UpdateFilterByTile ()
| Set the filter type according to the depot type.
StringID | GetCargoFilterLabel (CargoType cargo_type) const
void | SetCargoFilterArray ()
| Populate the filter list and set the cargo filter criteria.
void | SelectEngine (EngineID engine)
void | OnInit () override
| Notification that the nested widget tree gets initialized.
void | FilterEngineList ()
| Filter the engine list against the currently selected cargo filter.
bool | FilterSingleEngine (EngineID eid)
| Filter a single engine.
bool | FilterByText (const Engine *e)
| Filter by name and NewGRF extra text.
void | GenerateBuildTrainList (GUIEngineList &list)
void | GenerateBuildRoadVehList ()
void | GenerateBuildShipList ()
void | GenerateBuildAircraftList ()
void | GenerateBuildList ()
DropDownList | BuildCargoDropDownList () const
DropDownList | BuildBadgeConfigurationList () const
void | BuildVehicle ()
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
std::string | GetWidgetString (WidgetID widget, StringID stringid) const override
| Get the raw string for a widget.
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | OnPaint () override
| The window must be repainted.
void | OnQueryTextFinished (std::optional< std::string > str) override
| The query window opened from this window has closed.
void | OnDropdownSelect (WidgetID widget, int index, int click_result) override
| A dropdown option associated to this window has been selected.
void | OnResize () override
| Called after the window got resized.
void | OnEditboxChanged (WidgetID wid) override
| The text in an editbox has been edited.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (size_t from, size_t to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, std::string_view str, bool marked, std::optional< size_t > caret, std::optional< size_t > insert_location, std::optional< size_t > replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
Window * | FindChildWindowById (WindowClass wc, WindowNumber number) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
void | CloseChildWindowById (WindowClass wc, WindowNumber number) const
| Close all children a window might have in a head-recursive manner.
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnMouseDrag (Point pt, WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, WidgetID widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnScrollbarScroll (WidgetID widget)
| Notify window that a scrollbar position has been updated.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel, WidgetID widget)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, int click_result, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.

## Data Fields
VehicleType | vehicle_type = VEH_INVALID
| Type of vehicles shown in the window.
union { |
RailType railtype |
| Rail type to show, or INVALID_RAILTYPE. More...
RoadType roadtype |
| Road type to show, or INVALID_ROADTYPE. More...
} | filter |
| Filter to apply.
bool | descending_sort_order = false
| Sort direction,.
uint8_t | sort_criteria = 0
| Current sort criterium.
bool | show_hidden_engines = false
| State of the 'show hidden engines' button.
bool | listview_mode = false
| If set, only display the available vehicles and do not show a 'build' button.
EngineID | sel_engine = EngineID::Invalid()
| Currently selected engine, or EngineID::Invalid()
EngineID | rename_engine = EngineID::Invalid()
| Engine being renamed.
GUIEngineList | eng_list {}
CargoType | cargo_filter_criteria {}
| Selected cargo filter.
int | details_height = 0
| Minimal needed height of the details panels, in text lines (found so far).
Scrollbar * | vscroll = nullptr
TestedEngineDetails | te {}
| Tested cost and capacity after refit.
GUIBadgeClasses | badge_classes {}
StringFilter | string_filter {}
| Filter for vehicle name.
QueryString | vehicle_editbox
| Filter editbox.
std::pair< WidgetID, WidgetID > | badge_filters {}
| First and last widgets IDs of badge filters.
BadgeFilterChoices | badge_filter_choices {}
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags {}
| Window flags.
WindowClass | window_class {}
| Window class.
WindowNumber | window_number = 0
| Window number within the window class.
int | scale = 0
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer = 0
| Timer value of the WindowFlag::Timeout for flags.
uint8_t | white_border_timer = 0
| Timer value of the WindowFlag::WhiteBorder for flags.
int | left = 0
| x position of left edge of the window
int | top = 0
| y position of top edge of the window
int | width = 0
| width of the window (number of pixels to the right in x direction)
int | height = 0
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize {}
| Resize information.
Owner | owner = INVALID_OWNER
| The owner of the content shown in this window. Company colour is acquired from this variable.
std::unique_ptr< ViewportData > | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus = nullptr
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings {}
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root {}
| Root of the nested tree.
WidgetLookup | widget_lookup {}
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select = nullptr
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size {}
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget = INVALID_WIDGET
| ID of current mouse capture widget (e.g. dragged scrollbar). `INVALID_WIDGET` if no widget has mouse capture.
Window * | parent = nullptr
| Parent window.
WindowList::iterator | z_position {}

## Static Public Attributes
static constexpr int | BADGE_COLUMNS = 3
| Number of columns available for badges (0 = left of image, 1 = between image and name, 2 = after name)
static HotkeyList | hotkeys

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height, bool allow_resize)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data {}
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize = false
| Set if window has been resized.

## Detailed Description

GUI for building vehicles.

Definition at line 1154 of file build_vehicle_gui.cpp.

## Constructor & Destructor Documentation

## ◆ BuildVehicleWindow()

BuildVehicleWindow::BuildVehicleWindow | ( | WindowDesc & | desc,
|  | TileIndex | tile,
|  | VehicleType | type
| ) |  |
| inline

Definition at line 1195 of file build_vehicle_gui.cpp.

## Member Function Documentation

## ◆ BuildBadgeConfigurationList()

DropDownList BuildVehicleWindow::BuildBadgeConfigurationList | ( |  | ) | const
| inline

Definition at line 1616 of file build_vehicle_gui.cpp.

## ◆ BuildCargoDropDownList()

DropDownList BuildVehicleWindow::BuildCargoDropDownList | ( |  | ) | const
| inline

Definition at line 1592 of file build_vehicle_gui.cpp.

## ◆ BuildVehicle()

void BuildVehicleWindow::BuildVehicle | ( |  | ) |
| inline

Definition at line 1622 of file build_vehicle_gui.cpp.

## ◆ DrawWidget()

void BuildVehicleWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1841 of file build_vehicle_gui.cpp.

References DEFAULT_GROUP, DrawEngineList(), Window::DrawSortButtonState(), SBS_DOWN, SBS_UP, WID_BV_LIST, and WID_BV_SORT_ASCENDING_DESCENDING.

## ◆ FilterByText()

bool BuildVehicleWindow::FilterByText | ( | const Engine * | e | ) |
| inline

Filter by name and NewGRF extra text.

Definition at line 1362 of file build_vehicle_gui.cpp.

References GetNewGRFAdditionalText(), StringFilter::GetState(), GetString(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, StringFilter::IsEmpty(), PackEngineNameDParam(), PurchaseList, StringFilter::ResetState(), and string_filter.

## ◆ FilterEngineList()

void BuildVehicleWindow::FilterEngineList | ( |  | ) |
| inline

Filter the engine list against the currently selected cargo filter.

Definition at line 1344 of file build_vehicle_gui.cpp.

References cargo_filter_criteria, GUIEngineListItem::engine_id, and GUIList< T, P, F >::Filter().

## ◆ FilterSingleEngine()

bool BuildVehicleWindow::FilterSingleEngine | ( | EngineID | eid | ) |
| inline

Filter a single engine.

Definition at line 1355 of file build_vehicle_gui.cpp.

References cargo_filter_criteria, and CargoAndEngineFilter().

## ◆ GenerateBuildAircraftList()

void BuildVehicleWindow::GenerateBuildAircraftList | ( |  | ) |
| inline

Definition at line 1502 of file build_vehicle_gui.cpp.

## ◆ GenerateBuildList()

void BuildVehicleWindow::GenerateBuildList | ( |  | ) |
| inline

Definition at line 1537 of file build_vehicle_gui.cpp.

## ◆ GenerateBuildRoadVehList()

void BuildVehicleWindow::GenerateBuildRoadVehList | ( |  | ) |
| inline

Definition at line 1450 of file build_vehicle_gui.cpp.

## ◆ GenerateBuildShipList()

void BuildVehicleWindow::GenerateBuildShipList | ( |  | ) |
| inline

Definition at line 1477 of file build_vehicle_gui.cpp.

## ◆ GenerateBuildTrainList()

void BuildVehicleWindow::GenerateBuildTrainList | ( | GUIEngineList & | list | ) |
| inline

Definition at line 1379 of file build_vehicle_gui.cpp.

## ◆ GetCargoFilterLabel()

StringID BuildVehicleWindow::GetCargoFilterLabel | ( | CargoType | cargo_type | ) | const
| inline

Definition at line 1281 of file build_vehicle_gui.cpp.

## ◆ GetWidgetString()

std::string BuildVehicleWindow::GetWidgetString | ( | WidgetID | widget,
|  | StringID | stringid
| ) |  | const
| inlineoverridevirtual

Get the raw string for a widget.

Calls to this function are also made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.
  stringid | StringID assigned to widget.

Returns
  raw string to display.

Reimplemented from Window.

Definition at line 1758 of file build_vehicle_gui.cpp.

References _engine_sort_listing, _local_company, badge_filters, RailTypeInfo::build_caption, RoadTypeInfo::build_caption, cargo_filter_criteria, filter, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_engine_pool >::Get(), GetRailTypeInfo(), GetRoadTypeInfo(), GetString(), Window::GetWidgetString(), Engine::IsHidden(), IsInsideMM(), RailTypeInfo::strings, RoadTypeInfo::strings, VEH_ROAD, VEH_TRAIN, WID_BV_CAPTION, WID_BV_CARGO_FILTER_DROPDOWN, WID_BV_SHOW_HIDE, and WID_BV_SORT_DROPDOWN.

## ◆ OnClick()

void BuildVehicleWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1651 of file build_vehicle_gui.cpp.

References _ctrl_pressed, _current_company, _current_text_dir, _engine_sort_last_order, _engine_sort_show_hidden_engines, _local_company, badge_filters, cargo_filter_criteria, CS_ALPHANUMERAL, descending_sort_order, Engine::display_flags, DisplayVehicleSortDropDown(), EnableDefault, GUIEngineListItem::engine_id, GUIEngineListItem::flags, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Flip(), GUIList< T, P, F >::ForceRebuild(), Generic, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_engine_pool >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_company_pool >::Get(), Scrollbar::GetScrolledItemFromWidget(), GetString(), HasVariants, GUIEngineListItem::indent, InvalidateWindowClassesData(), InvalidateWindowData(), IsFolded, Engine::IsHidden(), IsInsideMM(), LengthIsInChars, MAX_LENGTH_ENGINE_NAME_CHARS, OnClick(), PackEngineNameDParam(), Persist, WidgetDimensions::scaled, sel_engine, Window::SetDirty(), Window::SetWidgetLoweredState(), Shaded, show_hidden_engines, ShowDropDownList(), ShowQueryString(), Rect::Shrink(), TD_RTL, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), GUIEngineListItem::variant_id, vehicle_type, WC_BUILD_VEHICLE, WC_REPLACE_VEHICLE, WID_BV_BUILD, WID_BV_CARGO_FILTER_DROPDOWN, WID_BV_CONFIGURE_BADGES, WID_BV_LIST, WID_BV_RENAME, WID_BV_SHOW_HIDDEN_ENGINES, WID_BV_SHOW_HIDE, WID_BV_SORT_ASCENDING_DESCENDING, WID_BV_SORT_DROPDOWN, and Rect::WithWidth().

Referenced by OnClick().

## ◆ OnDropdownSelect()

void BuildVehicleWindow::OnDropdownSelect | ( | WidgetID | widget,
|  | int | index,
|  | int | click_result
| ) |  |
| inlineoverridevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1899 of file build_vehicle_gui.cpp.

References _engine_sort_last_cargo_criteria, _engine_sort_last_criteria, BADGE_COLUMNS, badge_filters, cargo_filter_criteria, CargoFilterCriteria::CF_ANY, Window::CloseChildWindows(), GUIList< T, P, F >::ForceRebuild(), IsInsideMM(), Window::ReInit(), Window::SetDirty(), GUIList< T, P, F >::SetFilterState(), sort_criteria, vehicle_type, WC_DROPDOWN_MENU, WID_BV_CARGO_FILTER_DROPDOWN, WID_BV_CONFIGURE_BADGES, and WID_BV_SORT_DROPDOWN.

## ◆ OnEditboxChanged()

void BuildVehicleWindow::OnEditboxChanged | ( | WidgetID | widget | ) |
| inlineoverridevirtual

The text in an editbox has been edited.

Parameters

  widget | The widget of the editbox.

Reimplemented from Window.

Definition at line 1956 of file build_vehicle_gui.cpp.

References Textbuf::GetText(), Window::InvalidateData(), StringFilter::SetFilterTerm(), string_filter, and WID_BV_FILTER.

## ◆ OnInit()

void BuildVehicleWindow::OnInit | ( |  | ) |
| inlineoverridevirtual

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note
  nested_root and/or widget_lookup (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 1332 of file build_vehicle_gui.cpp.

References badge_filters, Window::nested_root, SetCargoFilterArray(), WID_BV_BADGE_FILTER, and Window::widget_lookup.

## ◆ OnInvalidateData()

void BuildVehicleWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 1745 of file build_vehicle_gui.cpp.

References _engine_sort_last_criteria, _settings_game, GUIList< T, P, F >::ForceRebuild(), VehicleSettings::roadveh_acceleration_model, VEH_ROAD, and GameSettings::vehicle.

## ◆ OnPaint()

void BuildVehicleWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1863 of file build_vehicle_gui.cpp.

References _network_server, _networking, details_height, DrawVehiclePurchaseInfo(), Window::DrawWidgets(), FS_NORMAL, GetCharacterHeight(), Window::IsShaded(), Window::ReInit(), Window::resize, WidgetDimensions::scaled, Scrollbar::SetCount(), Window::SetWidgetDisabledState(), Window::SetWidgetsDisabledState(), Rect::Shrink(), WID_BV_BUILD, WID_BV_PANEL, WID_BV_RENAME, and WID_BV_SHOW_HIDE.

## ◆ OnQueryTextFinished()

void BuildVehicleWindow::OnQueryTextFinished | ( | std::optional< std::string > | str | ) |
| inlineoverridevirtual

The query window opened from this window has closed.

Parameters

  str | the new value of the string, `std::nullopt` if the window was cancelled or an empty string when the default button was pressed, i.e. `str->empty()`.

Reimplemented from Window.

Definition at line 1892 of file build_vehicle_gui.cpp.

## ◆ OnResize()

void BuildVehicleWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1951 of file build_vehicle_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_BV_LIST.

## ◆ SelectEngine()

void BuildVehicleWindow::SelectEngine | ( | EngineID | engine | ) |
| inline

Definition at line 1302 of file build_vehicle_gui.cpp.

## ◆ SetBuyVehicleText()

void BuildVehicleWindow::SetBuyVehicleText | ( |  | ) |
| inline

Definition at line 1181 of file build_vehicle_gui.cpp.

## ◆ SetCargoFilterArray()

void BuildVehicleWindow::SetCargoFilterArray | ( |  | ) |
| inline

Populate the filter list and set the cargo filter criteria.

Definition at line 1292 of file build_vehicle_gui.cpp.

References _standard_cargo_mask, cargo_filter_criteria, CargoFilterCriteria::CF_ANY, HasBit(), GUIList< T, P, F >::SetFilterFuncs(), GUIList< T, P, F >::SetFilterState(), and vehicle_type.

Referenced by OnInit().

## ◆ UpdateFilterByTile()

void BuildVehicleWindow::UpdateFilterByTile | ( |  | ) |
| inline

Set the filter type according to the depot type.

Definition at line 1252 of file build_vehicle_gui.cpp.

References filter, GetRailType(), INVALID_RAILTYPE, INVALID_ROADTYPE, VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, VEH_TRAIN, and Window::window_number.

## ◆ UpdateWidgetSize()

void BuildVehicleWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 1795 of file build_vehicle_gui.cpp.

References EIT_PURCHASE, FS_NORMAL, GetCharacterHeight(), GetDropDownListDimension(), GetEngineListHeight(), GetString(), GetStringBoundingBox(), GetVehicleImageCellSize(), maxdim(), Window::resize, Window::SortButtonWidth(), WID_BV_BUILD, WID_BV_CARGO_FILTER_DROPDOWN, WID_BV_CONFIGURE_BADGES, WID_BV_LIST, WID_BV_PANEL, WID_BV_SHOW_HIDE, WID_BV_SORT_ASCENDING_DESCENDING, and Window::width.

## Field Documentation

## ◆ badge_classes

GUIBadgeClasses BuildVehicleWindow::badge_classes {}

Definition at line 1171 of file build_vehicle_gui.cpp.

## ◆ BADGE_COLUMNS

constexpr int BuildVehicleWindow::BADGE_COLUMNS = 3
| staticconstexpr

Number of columns available for badges (0 = left of image, 1 = between image and name, 2 = after name)

Definition at line 1173 of file build_vehicle_gui.cpp.

Referenced by OnDropdownSelect().

## ◆ badge_filter_choices

BadgeFilterChoices BuildVehicleWindow::badge_filter_choices {}

Definition at line 1179 of file build_vehicle_gui.cpp.

## ◆ badge_filters

std::pair<WidgetID, WidgetID> BuildVehicleWindow::badge_filters {}

First and last widgets IDs of badge filters.

Definition at line 1178 of file build_vehicle_gui.cpp.

Referenced by GetWidgetString(), OnClick(), OnDropdownSelect(), and OnInit().

## ◆ cargo_filter_criteria

CargoType BuildVehicleWindow::cargo_filter_criteria {}

Selected cargo filter.

Definition at line 1167 of file build_vehicle_gui.cpp.

Referenced by FilterEngineList(), FilterSingleEngine(), GetWidgetString(), OnClick(), OnDropdownSelect(), and SetCargoFilterArray().

## ◆ descending_sort_order

bool BuildVehicleWindow::descending_sort_order = false

Sort direction,.

See also
  _engine_sort_direction

Definition at line 1160 of file build_vehicle_gui.cpp.

Referenced by OnClick().

## ◆ details_height

int BuildVehicleWindow::details_height = 0

Minimal needed height of the details panels, in text lines (found so far).

Definition at line 1168 of file build_vehicle_gui.cpp.

Referenced by OnPaint().

## ◆ eng_list

GUIEngineList BuildVehicleWindow::eng_list {}

Definition at line 1166 of file build_vehicle_gui.cpp.

## ◆ hotkeys

HotkeyList BuildVehicleWindow::hotkeys
| inlinestatic

Initial value:
{"buildvehicle", {
Hotkey('F', "focus_filter_box", WID_BV_FILTER),
}}
WID_BV_FILTER
@ WID_BV_FILTER
Filter by name.
Definition build_vehicle_widget.h:19
Hotkey
All data for a single hotkey.
Definition hotkeys.h:21

Definition at line 1964 of file build_vehicle_gui.cpp.

## ◆ listview_mode

bool BuildVehicleWindow::listview_mode = false

If set, only display the available vehicles and do not show a 'build' button.

Definition at line 1163 of file build_vehicle_gui.cpp.

## ◆ railtype

RailType BuildVehicleWindow::railtype

Rail type to show, or INVALID_RAILTYPE.

Definition at line 1157 of file build_vehicle_gui.cpp.

## ◆ rename_engine

EngineID BuildVehicleWindow::rename_engine = EngineID::Invalid()

Engine being renamed.

Definition at line 1165 of file build_vehicle_gui.cpp.

## ◆ roadtype

RoadType BuildVehicleWindow::roadtype

Road type to show, or INVALID_ROADTYPE.

Definition at line 1158 of file build_vehicle_gui.cpp.

## ◆ sel_engine

EngineID BuildVehicleWindow::sel_engine = EngineID::Invalid()

Currently selected engine, or EngineID::Invalid()

Definition at line 1164 of file build_vehicle_gui.cpp.

Referenced by OnClick().

## ◆ show_hidden_engines

bool BuildVehicleWindow::show_hidden_engines = false

State of the 'show hidden engines' button.

Definition at line 1162 of file build_vehicle_gui.cpp.

Referenced by OnClick().

## ◆ sort_criteria

uint8_t BuildVehicleWindow::sort_criteria = 0

Current sort criterium.

Definition at line 1161 of file build_vehicle_gui.cpp.

Referenced by OnDropdownSelect().

## ◆ string_filter

StringFilter BuildVehicleWindow::string_filter {}

Filter for vehicle name.

Definition at line 1175 of file build_vehicle_gui.cpp.

Referenced by FilterByText(), and OnEditboxChanged().

## ◆ te

TestedEngineDetails BuildVehicleWindow::te {}

Tested cost and capacity after refit.

Definition at line 1170 of file build_vehicle_gui.cpp.

## ◆ vehicle_editbox

QueryString BuildVehicleWindow::vehicle_editbox

Filter editbox.

Definition at line 1176 of file build_vehicle_gui.cpp.

## ◆ vehicle_type

VehicleType BuildVehicleWindow::vehicle_type = VEH_INVALID

Type of vehicles shown in the window.

Definition at line 1155 of file build_vehicle_gui.cpp.

Referenced by OnClick(), OnDropdownSelect(), and SetCargoFilterArray().

## ◆ vscroll

Scrollbar* BuildVehicleWindow::vscroll = nullptr

Definition at line 1169 of file build_vehicle_gui.cpp.

The documentation for this struct was generated from the following file:

- src/build_vehicle_gui.cpp